
// MFCApplication1View.cpp : implementation of the CMFCApplication1View class
//

#include "stdafx.h"
// SHARED_HANDLERS can be defined in an ATL project implementing preview, thumbnail
// and search filter handlers and allows sharing of document code with that project.
#ifndef SHARED_HANDLERS
#include "MFCApplication1.h"
#endif

#include "MFCApplication1Doc.h"
#include "MFCApplication1View.h"
#include "MainFrm.h"

/////////// TeeChart header
#include "TeeChartDefines.h"
#include "TeeFont.h"
#include "TeeGDIPlus.h"
#include "Aspect.h"
#include "Axes.h"
#include "Axis.h"
#include "AxisLabels.h"
#include "AxisTitle.h"
#include "BMPExport.h"
#include "Brush.h"
#include "Canvas.h"
#include "ChartFont.h"
#include "Environment.h"
#include "Export.h"
#include "JPEGExport.h"
#include "Legend.h"
#include "LineSeries.h"
#include "MetafileExport.h"
#include "Panel.h"
#include "PDFExport.h"
#include "Pen.h"
#include "PNGExport.h"
#include "Point3DSeries.h"
#include "Pointer.h"
#include "Printer.h"
#include "Scroll.h"
#include "Series.h"
#include "SurfaceSeries.h"
#include "Titles.h"
#include "ValueList.h"
#include "Walls.h"
#include "Wall.h"
#include "Zoom.h"
#include "Strings.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMFCApplication1View

IMPLEMENT_DYNCREATE(CMFCApplication1View, CView)

BEGIN_MESSAGE_MAP(CMFCApplication1View, CView)
	//{{AFX_MSG_MAP(CMFCApplication1View)
	ON_WM_SIZE()			//call OnSize()
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, OnFilePrintDirect)
//	ON_COMMAND(ID_FILE_PRINT_PREVIEW, OnFilePrintPreview)
END_MESSAGE_MAP()

// CMFCApplication1View construction/destruction

CMFCApplication1View::CMFCApplication1View()
{
	// TODO: add construction code here

}

CMFCApplication1View::~CMFCApplication1View()
{
}

BOOL CMFCApplication1View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

BOOL CMFCApplication1View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, 
								DWORD dwStyle, const RECT &rect, CWnd *pParentWnd, 
								UINT nID, CCreateContext *pContext)
{
	if (!CWnd::Create(lpszClassName, lpszWindowName, dwStyle, rect, 
		pParentWnd, nID, pContext))
		return FALSE;
	
	//////////////////////////////////////////////////////////////
	//WS_CHILD | WS_VISIBLE
	//Create TeeChart - sized to Client window afterwards with 'OnSize'
	if (!m_pChart.Create(lpszClassName, dwStyle, CRect(0,0,800,400), this, IDC_TCHART))
		return FALSE;

	return true;
}

void CMFCApplication1View::OnSize(UINT nType, int cx, int cy)
{
	CView::OnSize(nType, cx, cy);
	
	 //routine sizes the Chart to the Client window
     if (m_pChart.m_hWnd)
     {
          m_pChart.SetWidth(cx);
          m_pChart.SetHeight(cy);
	 }
}


void CMFCApplication1View::OnInitialUpdate()
{
	CView::OnInitialUpdate();

	CMainFrame	*pMF = (CMainFrame*)AfxGetMainWnd();

	/////////////////////////////////////
	// TeeChart Initialization
	// Initializing the Chart properties
	m_pChart.ClearChart();
	m_pChart.SetVisible(true);
	m_pChart.GetAspect().GetGDIPlus().SetActive(TRUE);	// cause printing issue - a bug of TeeChart
	m_pChart.GetAspect().SetOrthogonal(FALSE);
	m_pChart.GetLegend().SetVisible(TRUE);
	m_pChart.GetLegend().SetWidth(50);
	m_pChart.GetPanel().SetColor(RGB(255,255,255));

	m_pChart.GetHeader().GetFont().SetSize(12);
	m_pChart.GetSubHeader().GetFont().SetSize(11);

	m_pChart.GetAxis().GetLeft().GetLabels().SetOnAxis(TRUE);
	m_pChart.GetAxis().GetBottom().GetLabels().SetOnAxis(TRUE);
	m_pChart.GetAxis().GetDepth().GetLabels().SetOnAxis(TRUE);

	m_pChart.GetAxis().GetLeft().GetLabels().GetFont().SetSize(10);
	m_pChart.GetAxis().GetBottom().GetLabels().GetFont().SetSize(10);
	m_pChart.GetAxis().GetDepth().GetLabels().GetFont().SetSize(10);

	m_pChart.GetAxis().GetLeft().GetTitle().GetFont().SetSize(11);
	m_pChart.GetAxis().GetBottom().GetTitle().GetFont().SetSize(11);
	m_pChart.GetAxis().GetDepth().GetTitle().GetFont().SetSize(11);

	m_pChart.GetZoom().SetEnable(FALSE);
	m_pChart.GetZoom().SetDirection(tzdBoth);
	m_pChart.GetZoom().SetMouseButton(mbMiddle);
	m_pChart.GetScroll().SetEnable(pmNone);	//pmNone, pmBoth, pmVertical

	// set printing properties
	m_pChart.GetPrinter().SetJobTitle(_T("Printing"));
	m_pChart.GetPrinter().SetPrintProportional(false);
	m_pChart.GetPrinter().SetOrientation(poLandscape);
	m_pChart.GetPrinter().SetMarginTop(5);
	m_pChart.GetPrinter().SetMarginBottom(5);
	m_pChart.GetPrinter().SetMarginLeft(5);
	m_pChart.GetPrinter().SetMarginRight(5);

	m_pChart.RemoveAllSeries();

	///////////////////////////////////////
	// 2-D View: Series 0
	m_pChart.GetAspect().SetView3D(FALSE);
	m_pChart.GetAspect().SetZoom(70);
	m_pChart.GetWalls().GetBack().SetVisible(TRUE);
	m_pChart.GetAxis().GetLeft().SetVisible(TRUE);
	m_pChart.GetAxis().GetBottom().GetLabels().SetSize(0);
	m_pChart.AddSeries(scLine);		// series 0
	m_pChart.Series(0).SetActive(true);
	m_pChart.Series(0).SetShowInLegend(FALSE);
//	m_pChart.Series(0).SetName("2D_View");
	m_pChart.Series(0).GetPen().SetWidth(3);

	m_pChart.Series(0).GetXValues().SetOrder(loNone);
	m_pChart.Series(0).GetYValues().SetOrder(loNone);

	m_pChart.GetAxis().GetLeft().SetInverted(TRUE);
	m_pChart.GetAxis().GetLeft().GetTitle().SetCaption(LPCTSTR("Where You Are"));
	m_pChart.GetAxis().GetBottom().GetTitle().SetCaption(LPCTSTR("I'm OK"));

	m_pChart.GetHeader().SetCaption(LPCTSTR("2D View"));

	COleVariant	oTitle = _T("Test Smaple");
	m_pChart.GetSubHeader().GetText().Add(*(LPCVARIANT)oTitle);
	oTitle = _T("Improper Text Alignment");
	m_pChart.GetSubHeader().GetText().Add(*(LPCVARIANT)oTitle);

	////////////////////////////////////////////
	for (int n=0; n<100; n++)
	{
		CSeries sCurve = m_pChart.Series(0);
		sCurve.SetActive(true);
		sCurve.SetShowInLegend(FALSE);
		sCurve.GetPen().SetWidth(3);
		sCurve.SetColor(RGB(0,0,0));
		sCurve.GetAsLine().SetColorEachLine(FALSE);
		sCurve.GetXValues().SetOrder(loNone);
		sCurve.GetYValues().SetOrder(loNone);
		sCurve.AddXY(n*10, n*n * 10, _T(""), 255);
	}

	m_pChart.SetFocus();		// to catch the mousewheel event
}


// CMFCApplication1View drawing

void CMFCApplication1View::OnDraw(CDC* /*pDC*/)
{
	CMFCApplication1Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

}


void CMFCApplication1View::OnFilePrint() 
{
	if (m_pChart.GetPrinter().ShowSetupDlg())
		m_pChart.GetPrinter().PrintChart();
}

void CMFCApplication1View::OnFilePrintDirect() 
{
	m_pChart.GetPrinter().PrintChart();
}

// CMFCApplication1View printing

BOOL CMFCApplication1View::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CMFCApplication1View::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	m_pChart.GetPrinter().PrintChart();
}

void CMFCApplication1View::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


// CMFCApplication1View diagnostics

#ifdef _DEBUG
void CMFCApplication1View::AssertValid() const
{
	CView::AssertValid();
}

void CMFCApplication1View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMFCApplication1Doc* CMFCApplication1View::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMFCApplication1Doc)));
	return (CMFCApplication1Doc*)m_pDocument;
}
#endif //_DEBUG


// CMFCApplication1View message handlers
